desc 'Generates a secret token for the application.'
task :generate_secret_token do

ENV['X_DEBIAN_SITEID'] ||= 'default'
ENV['RAILS_ETC'] ||= "/etc/redmine/#{ENV['X_DEBIAN_SITEID']}"
filename = ENV['YML_SESSION_FILENAME'] ? ENV['YML_SESSION_FILENAME'] : 'session.yml'
path = File.join(ENV['RAILS_ETC'] ? ENV['RAILS_ETC'] : File.join(Rails.root, 'config'), filename)
secret = SecureRandom.hex(40)
File.open(path, 'w') do |f|
  f.write <<"EOF"
# This file was generated by 'rake generate_session_store',
# not be made visible to public.
# If you have a load-balancing Redmine cluster, you will need to use the
# same version of this file on each machine. And be sure to restart your
# server when you modify this file.
#
# Your secret key for verifying cookie session data integrity. If you
# change this key, all old sessions will become invalid! Make sure the
# secret is at least 30 characters and all random, no regular words or
# you'll be exposed to dictionary attacks.

production:
  key: _redmine_#{ENV['X_DEBIAN_SITEID']}
  secret: #{secret}

development:
  key: _redmine_#{ENV['X_DEBIAN_SITEID']}
  secret: #{secret}

test:
  key: _redmine_#{ENV['X_DEBIAN_SITEID']}
  secret: #{secret}
EOF
  end
end
